-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

-- get the library
local lib = ns.lib
lib.classes["WARRIOR"] = {}
local t,s

lib.classes["WARRIOR"][2] = function () --Fury
	cfg.talents={
	["Enhanced_Whirlwind_Perk"]=IsPlayerSpell(157473)
	}
	lib.AddSpell("bt",{23881}) -- Bloodthirst
	lib.AddAura("Enrage",12880,"buff","player") -- Enrage --,18499
	lib.SetTrackAura("Enrage")
	lib.SetAuraFunction("Enrage","OnApply",function()
		lib.UpdateTrackAura(cfg.GUID["player"],0)
	end)
	lib.SetAuraFunction("Enrage","OnFade",function()
		lib.UpdateTrackAura(cfg.GUID["player"])
	end)
	
	lib.AddSpell("ws",{100130}) -- Wild Strike
	lib.AddAura("Bloodsurge",46916,"buff","player") -- Bloodsurge
	lib.AddSpell("rb",{85288}) -- Raging Blow	
	lib.AddAura("rb",131116,"buff","player") -- Raging Blow!
	lib.AddSpell("Dragon_Roar",{118000}) -- Dragon Roar	
	lib.AddSpell("Storm Bolt",{107570}) -- Storm Bolt	
	lib.AddSpell("Berserker_Rage",{18499}) -- Berserker Rage
	lib.AddSpell("Bloodbath",{12292},true) -- Bloodbath
	
	--lib.AddSpell("cs",{86346}) -- Colossus Smash
	--lib.AddSpell("slam",{1464}) -- Slam
	
	
	--lib.AddSpell("dw",{12292}) -- Death Wish
	--lib.AddSpell("hs",{78}) -- Heroic Strike

	
	--lib.AddSpell("ir",{1134}) -- Inner Rage
	--lib.AddSpell("cleave",{845}) -- Cleave
	lib.AddSpell("ww",{1680}) -- Whirlwind
	if cfg.talents["Enhanced_Whirlwind_Perk"] then
		cfg.ww=4
	else
		cfg.ww=3
	end
	lib.AddAura("Meat_Cleaver",85739,"buff","player") -- Meat Cleaver
	--lib.AddAura("Executioner",90806,"buff","player") -- Executioner
	--lib.AddAura("Trance",12964,"buff","player") -- Battle Trance
	--lib.AddAura("Incite",86627,"buff","player") -- Incite
	
	
		
	cfg.plistdps = {}
	--table.insert(cfg.plistdps,"hs_Trance")
	--table.insert(cfg.plistdps,"execute_end")
	--table.insert(cfg.plistdps,"cs")
	--table.insert(cfg.plistdps,"execute_5stack")
	--table.insert(cfg.plistdps,"bt")
	--table.insert(cfg.plistdps,"Enrage")
	--table.insert(cfg.plistdps,"rb")
	table.insert(cfg.plistdps,"shout_nobuff")
	table.insert(cfg.plistdps,"Charge_range")
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"Victory_health")
	table.insert(cfg.plistdps,"Recklessness")
	table.insert(cfg.plistdps,"Bloodbath")
	table.insert(cfg.plistdps,"execute_SD")
	table.insert(cfg.plistdps,"ws_90_noExecute")
	table.insert(cfg.plistdps,"execute_Enrage")
	table.insert(cfg.plistdps,"rb_2")
	table.insert(cfg.plistdps,"br_noEnrage")
	table.insert(cfg.plistdps,"bt_noEnrage")
	table.insert(cfg.plistdps,"ws_Bloodsurge")
	table.insert(cfg.plistdps,"Dragon_Roar")
	table.insert(cfg.plistdps,"rb")
	table.insert(cfg.plistdps,"ws_Enrage_noExecute")
	table.insert(cfg.plistdps,"bt")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
	table.insert(cfg.plistaoe,"shout_nobuff")
	table.insert(cfg.plistaoe,"Charge_range")
	table.insert(cfg.plistaoe,"Kick")
	table.insert(cfg.plistaoe,"Victory_health")
	table.insert(cfg.plistaoe,"Bloodbath")
	table.insert(cfg.plistaoe,"execute_SD")
	table.insert(cfg.plistaoe,"execute_Enrage")
	table.insert(cfg.plistaoe,"br_noEnrage")
	table.insert(cfg.plistaoe,"bt_noEnrage")
	table.insert(cfg.plistaoe,"ww_Meat_Cleaver")
	table.insert(cfg.plistaoe,"rb")
	table.insert(cfg.plistaoe,"Dragon_Roar")
	table.insert(cfg.plistaoe,"ws_Bloodsurge")
	table.insert(cfg.plistaoe,"bt")
	table.insert(cfg.plistaoe,"end")

	cfg.plist=cfg.plistdps

	cfg.case = {}
	cfg.case = {
		["ww_Meat_Cleaver"] = function ()
			if lib.GetAuraStacks("Meat_Cleaver")<cfg.ww then
				return lib.SimpleCDCheck("ww")
			else
				return lib.SimpleCDCheck("ww",lib.GetAuras("Meat_Cleaver")-3)
			end
			return nil
		end,
		["ws_Bloodsurge"] = function()
			if lib.GetAura({"Bloodsurge"})>lib.GetSpellCD("ws") then
				return lib.SimpleCDCheck("ws")
			end
			return nil
		end,
		
		["ws_90_noExecute"] = function()
			if lib.GetUnitHealth("target","percent")<=20 then return nil end
			if cfg.Power.now>=90 then
				return lib.SimpleCDCheck("ws")
			end
			return nil
		end,
		["bt_noEnrage"] = function ()
			return lib.SimpleCDCheck("bt",lib.GetAura({"Enrage"}))
		end,
		["br_noEnrage"] = function ()
			return lib.SimpleCDCheck("Berserker_Rage",lib.GetAura({"Enrage"}))
		end,
		["ws_Enrage_noExecute"] = function ()
			if lib.GetUnitHealth("target","percent")<=20 then return nil end
			if lib.GetAura({"Enrage"})>=lib.GetSpellCD("ws") and cfg.Power.now>=(lib.GetSpellCost("ws")+lib.GetSpellCost("rb")) then
				return lib.SimpleCDCheck("ws")
			end
			return nil
		end,
		["execute_Enrage"] = function ()
			if lib.GetAura({"Enrage"})>=lib.GetSpellCD("execute") then
				return lib.SimpleCDCheck("execute")
			end
			return nil
		end,
		["execute_SD"] = function()
			if lib.GetAura({"Sudden_Death"})>lib.GetSpellCD("execute") or cfg.Power.now>=90 then
				return lib.SimpleCDCheck("execute")
			end
			return nil
		end,
		["rb_2"] = function()
			if lib.GetAuraStacks("rb")>=2  then
				return lib.SimpleCDCheck("rb")
			end
			return nil
		end,
	
	
	------------------
		["execute_end"] = function()
			if cfg.Power.now>=20 then
				return lib.SimpleCDCheck("execute",lib.GetAura({"Executioner"})-1.5)
			end
			return nil
		end,
		["execute_5stack"] = function()
			if cfg.Power.now>=20 and lib.GetAuraStacks("Executioner")<5 then
				return lib.SimpleCDCheck("execute")
			end
			return nil
		end,
		["execute_50rage"] = function()
			if cfg.Power.now>=50 then
				return lib.SimpleCDCheck("execute")
			end
			return nil
		end,
		["rb_aoe"] = function()
			if cfg.Power.now >= 70  then
				return lib.SimpleCDCheck("rb")
			end
			return nil
		end,
		["cleave"] = function()
			if cfg.Power.now>=(lib.GetSpellCost("cleave")+lib.GetSpellCost("ww")) then
				return lib.SimpleCDCheck("cleave")
			end
			return nil
		end,
		["Enrage"] = function ()
			if cfg.Power.now>15 and lib.GetSpellCD(cfg.gcd,true)>0 then
				return lib.SimpleCDCheck("br",lib.GetAura({"Enrage"}))
			end
			return nil
		end,
		["hs_Trance"] = function ()
			if (lib.GetAura({"Trance"})>0 or cfg.Power.now >= 85) and lib.GetSpellCD(cfg.gcd,true)>0 then
				return lib.SimpleCDCheck("hs")
			end
			return nil
		end,
		["hs"] = function ()
			if cfg.Power.now == 100 then
				return lib.SimpleCDCheck("hs")
			end
			return nil
		end,
	}

	cfg.spells_aoe={"ww"}
	return true
end

lib.classes["WARRIOR"][10] = function ()
	
	lib.AddSpell("Rend",{772}) -- Rend
	lib.AddSpell("cs",{86346}) -- Colossus Smash
	lib.AddSpell("ms",{12294}) -- Mortal Strike
	lib.AddSpell("slam",{1464}) -- Slam
	lib.AddSpell("op",{7384}) -- Overpower
	
	lib.AddSpell("ir",{1134}) -- Inner Rage
	lib.AddSpell("cleave",{845}) -- Cleave
	lib.AddSpell("ss",{12328}) -- Sweeping Strikes
	lib.AddSpell("bls",{46924}) -- Bladestorm
	lib.AddSpell("vr",{34428}) -- Victory Rush
	lib.AddSpell("ww",{1680}) -- Whirlwind
	lib.AddSpell("Clap",{6343}) -- Thunder Clap
	lib.AddSpell("Berserker",{2458}) -- Berserker 
	lib.AddSpell("Battle",{2457}) -- Battle 
				
	lib.AddAura("Rend",94009,"debuff","target") -- Rend
	lib.AddAura("cs",86346,"debuff","target") -- Colossus Smash
	lib.AddAura("ToB",60503,"buff","player") -- Taste for Blood
	lib.AddAura("sd",52437,"buff","player") -- Sudden Death
	lib.AddAura("bs",46916,"buff","player") -- Bloodsurge
	lib.AddAura("Executioner",90806,"buff","player") -- Executioner
	lib.AddAura("Trance",12964,"buff","player") -- Battle Trance
	lib.AddAura("Incite",86627,"buff","player") -- Incite
	lib.AddAura("Enrage",14202,"buff","player") -- Enrage
	lib.AddAura("WC",57519,"buff","player") -- Wrecking Crew
	lib.AddAura("br",18499,"buff","player") -- Berserker Rage
	lib.AddAura("Calm",85730,"buff","player") -- Deadly Calm
	lib.AddAura("ir",1134,"buff","player") -- Inner Rage
	
		
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"Stance_Battle_Rend")
	table.insert(cfg.plistdps,"Rend_noRend")
	table.insert(cfg.plistdps,"br")
	table.insert(cfg.plistdps,"Stance_Berserker_Execute")
	table.insert(cfg.plistdps,"ms")
	table.insert(cfg.plistdps,"cs_nocs")
	table.insert(cfg.plistdps,"ms20")
	table.insert(cfg.plistdps,"Stance_Battle_OP")
	table.insert(cfg.plistdps,"op")
	table.insert(cfg.plistdps,"hs")
	table.insert(cfg.plistdps,"execute")
	table.insert(cfg.plistdps,"cs_nocs15")
	table.insert(cfg.plistdps,"slam")
	table.insert(cfg.plistdps,"bs_single")
	table.insert(cfg.plistdps,"end")
	
	cfg.plistaoe = {}
--	table.insert(cfg.plistaoe,"Stance_Berserker")
	table.insert(cfg.plistaoe,"Stance_Battle_Rend_aoe")
	table.insert(cfg.plistaoe,"Stance_Berserker_aoe")
	table.insert(cfg.plistaoe,"Rend_bns")
	table.insert(cfg.plistaoe,"Clap_bns")
	table.insert(cfg.plistaoe,"br")	
	table.insert(cfg.plistaoe,"bls")
	table.insert(cfg.plistaoe,"ww")
	table.insert(cfg.plistaoe,"cleave")
	table.insert(cfg.plistaoe,"ms_aoe")
--	table.insert(cfg.plistaoe,"ms")
	table.insert(cfg.plistaoe,"execute")
	table.insert(cfg.plistaoe,"bs_single")
	table.insert(cfg.plistaoe,"end")

	cfg.plist=cfg.plistdps
	
	cfg.case = {}
	cfg.case = {
		["execute"] = function()
			if cfg.Power.now>=20 then
				return lib.SimpleCDCheck("execute")
			end
			return nil
		end,
		["br"] = function()
			if cfg.Power.now<=95 then
				return lib.SimpleCDCheck("br")
			end
			return nil
		end,
		["slam"] = function ()
			if lib.SpellCasting("slam") then
				t=2
			else
				t=1
			end
			if cfg.Power.now>(lib.GetSpellCost("ms")+t*lib.GetSpellCost("slam")) or lib.GetAura({"Trance"})>0 or lib.GetAura({"Calm"})>0 then
				return lib.SimpleCDCheck("slam")
			end
			return nil
		end,
		["cs_nocs15"] = function()
			return lib.SimpleCDCheck("cs",(lib.GetAura({"cs"})-1.5))
		end,
		["cs_nocs"] = function()
			return lib.SimpleCDCheck("cs",lib.GetAura({"cs"}))
		end,
		["hs"] = function ()
		if lib.GetSpellCD(cfg.gcd,true)>0 then
			if lib.GetAura({"Calm"})>lib.GetSpellCD("hs") then
				return lib.SimpleCDCheck("hs")
			end
			if cfg.health>20 and cfg.Power.now>85 then
				return lib.SimpleCDCheck("hs")
			end
			if cfg.Power.now>75 and lib.GetAura({"ir"})>lib.GetSpellCD("hs") then
				return lib.SimpleCDCheck("hs")
			end
			if lib.GetAura({"Incite"})>lib.GetSpellCD("hs") and (cfg.health>20 or (cfg.health<=20 and lib.GetAura({"Trance"})>lib.GetSpellCD("hs"))) then
				return lib.SimpleCDCheck("hs")
			end
			if lib.GetAura({"ir"})>lib.GetSpellCD("hs") and cfg.health>20 and (cfg.Power.now>(lib.GetSpellCost("ms")+lib.GetSpellCost("hs")) or lib.GetAura({"Trance"})>lib.GetSpellCD("hs")) then
				return lib.SimpleCDCheck("hs")
			end
			if lib.GetAura({"ir"})>lib.GetSpellCD("hs") and cfg.health<=20 and (cfg.Power.now>=(lib.GetSpellCost("ms")+lib.GetSpellCost("hs")+lib.GetSpellCost("execute")) or lib.GetAura({"Trance"})>lib.GetSpellCD("hs")) then
				return lib.SimpleCDCheck("hs")
			end
		end
			return nil
		end,
		["Stance_Battle_OP"] = function()
			if cfg.shape~="Battle" and cfg.health>20 and lib.GetAura({"ToB"})>0 and cfg.Power.now<=75 and lib.GetSpellCD("ms",true)>1.5 and lib.GetSpellCD("cs",true)>1.5 then
				return lib.SimpleCDCheck("Battle")
			end
			return nil
		end,
		["Stance_Berserker_Execute"] = function()
			if cfg.shape~="Berserker" and cfg.health<=20 and lib.GetAura({"ToB"})==0 and cfg.Power.now<=75 and lib.GetAura({"Rend"})>lib.GetSpellCD("ms",true) then
				return lib.SimpleCDCheck("Berserker")
			end
			return nil
		end,
		["Stance_Berserker_aoe"] = function()
			if cfg.shape~="Berserker" and not cfg.bnt then
				return lib.SimpleCDCheck("Berserker")
			end
			return nil
		end,
		["ms"] = function()
			if cfg.health>20 then
				return lib.SimpleCDCheck("ms")
			end
			return nil
		end,
		["ms20"] = function()
			if cfg.health<=20 and (lib.GetAura({"WC"})==0 or lib.GetAura({"Rend"})<3 or cfg.Power.now<=25 or cfg.Power.now>=35)  then
				return lib.SimpleCDCheck("ms")
			end
			return nil
		end,
		["Rend_noRend"] = function()
			if not lib.GetLastSpell({"Rend"}) then
				return lib.SimpleCDCheck("Rend",lib.GetAura({"Rend"}))
			end
			return nil
		end,
		["Rend_bns"] = function()
			if cfg.bnt and not lib.GetLastSpell({"Rend"}) then
				return lib.SimpleCDCheck("Rend",lib.GetAura({"Rend"}))
			end
			return nil
		end,
		["Stance_Berserker"] = function()
			if cfg.shape~="Berserker" and lib.GetAura({"ToB"})==0 and lib.GetAura({"Rend"})>lib.GetSpellCD(cfg.gcd,true) and cfg.Power.now<=75 then
				return lib.SimpleCDCheck("Berserker")
			end
			return nil
		end,
		["Stance_Battle_Rend_aoe"] = function()
			if cfg.shape~="Battle" and lib.GetAura({"Rend"})<=lib.GetSpellCD(cfg.gcd,true) and cfg.bnt then
				return lib.SimpleCDCheck("Battle")
			end
			return nil
		end,
		["Stance_Battle_Rend"] = function()
			if cfg.shape~="Battle" and lib.GetAura({"Rend"})<=lib.GetSpellCD(cfg.gcd,true) then
				return lib.SimpleCDCheck("Battle")
			end
			return nil
		end,
		["Clap_bns"] = function()
			if cfg.bnt and lib.GetAura({"Rend"})>lib.GetSpellCD("Clap",true) then
				return lib.SimpleCDCheck("Clap")
			end
			return nil
		end,
		["ms_aoe"] = function()
			if lib.GetAura({"Calm"})>0 or cfg.Power.now>=(lib.GetSpellCost("ms")+lib.GetSpellCost("ww")+lib.GetSpellCost("cleave")) then
				return lib.SimpleCDCheck("ms")
			end
			return nil
		end,
		["ms_Rend"] = function()
			t = lib.GetAura({"Rend"})
			if t>0 and t<3 then
				return cfg.case["ms"]()
			end
			return nil
		end,
		["cleave"] = function()
			if cfg.Power.now>=(lib.GetSpellCost("cleave")+lib.GetSpellCost("ww")) then
				return lib.SimpleCDCheck("cleave")
			end
			return nil
		end,
		["br"] = function ()
			if lib.GetAura({"Enrage","dw","br"})==0 and lib.GetAura({"bs"})==0 and lib.GetAura({"Trance"})==0 then
				return lib.SimpleCDCheck("br")
			end
			return nil
		end,
		["bs_single"] = function ()
			if cfg.Power.now < 60 then
				return lib.SimpleCDCheck("bs")
			end
			return nil
		end,
	}
	cfg.spells_aoe={"cleave","bls","ww"}
	cfg.spells_single={"hs","ms","op","cs"}
	return true
end


lib.classes["WARRIOR"][3] = function ()
	lib.AddSpell("Revenge",{6572}) -- Revenge
	lib.AddSpell("Shield_Slam",{23922}) -- Shield Slam
	lib.AddAura("snb",50227,"buff","player") -- Sword and Board
	lib.AddAura("Unyielding_Strikes",169686,"buff","player") -- Unyielding Strikes
	lib.AddSpell("Devastate",{20243}) -- Devastate 
	lib.AddSpell("Shield_Block",{2565}) -- Shield Block
	lib.AddAura("Shield_Block",132404,"buff","player") -- Shield Block
	lib.AddSpell("Shield_Barrier",{112048},true) -- Shield Barrier
	lib.AddSpell("Clap",{6343}) -- Thunder Clap
	lib.AddAura("Deep_Wounds",115767,"debuff","target") -- Deep Wounds
	lib.AddSpell("Shockwave",{46968}) -- Shockwave
	lib.AddAura("Ultimatum",122510,"buff","player") -- Ultimatum
	lib.AddSpell("Shield Wall",{871},true) -- Shield Wall
	lib.AddSpell("Last Stand",{12975},true) -- Last Stand
	lib.AddSpell("Demoralizing Shout",{1160},"target") -- Demoralizing Shout 
	
	--[[lib.AddSpell("cb",{12809}) -- Concussion Blow
	
	lib.AddSpell("br",{18499}) -- Berserker Rage
	lib.AddSpell("ir",{1134}) -- Inner Rage

	lib.AddSpell("vr",{34428}) -- Victory Rush
	lib.AddSpell("hs",{78}) -- Heroic Strike
	lib.AddSpell("cleave",{845}) -- Cleave
	lib.AddSpell("ht",{57755}) -- Heroic Throw
				
	lib.AddAura("Rend",94009,"debuff","target") -- Rend
	
	lib.AddAura("ths",87096,"buff","player") -- Thunderstruck
	lib.AddAura("Incite",86627,"buff","player") -- Incite

	lib.AddAuras("Clap",{6343,54404,90315,8042,45477,58180,68055,51693},"debuff","target") -- Thunder Clap
	
	lib.AddAuras("Demo",{1160,702,99,50256,24423,81130,26017},"debuff","target") -- Demoralizing Shout ]]
	
	cfg.plistdps = {}
	table.insert(cfg.plistdps,"shout_nobuff")
	table.insert(cfg.plistdps,"Charge_range")
	table.insert(cfg.plistdps,"Kick")
	table.insert(cfg.plistdps,"Victory_health")
	table.insert(cfg.plistdps,"Shield_Block")
	table.insert(cfg.plistdps,"Shield_Barrier")
	table.insert(cfg.plistdps,"Shield_Slam_snb")
	table.insert(cfg.plistdps,"Revenge")
	table.insert(cfg.plistdps,"Shield_Slam")
	table.insert(cfg.plistdps,"execute_SD")
	table.insert(cfg.plistdps,"hs_6us")
	table.insert(cfg.plistdps,"Devastate")
	table.insert(cfg.plistdps,"hs_nomax")
	--[[table.insert(cfg.plistdps,"ht")
	table.insert(cfg.plistdps,"cb")
	table.insert(cfg.plistdps,"Clap_bnt")
	table.insert(cfg.plistdps,"ss")
	table.insert(cfg.plistdps,"vr")
	table.insert(cfg.plistdps,"rv") 
	table.insert(cfg.plistdps,"Rend_noRend")
	table.insert(cfg.plistdps,"des_noDemo")
	table.insert(cfg.plistdps,"Clap_noClap")
	table.insert(cfg.plistdps,"sw_ths")
	table.insert(cfg.plistdps,"sb")
	table.insert(cfg.plistdps,"ds")
	table.insert(cfg.plistdps,"hs")
	table.insert(cfg.plistdps,"bs")]]--
	table.insert(cfg.plistdps,"end")

	
	cfg.plistaoe = {}
--	table.insert(cfg.plistaoe,"vr")
	table.insert(cfg.plistaoe,"shout_nobuff")
	table.insert(cfg.plistaoe,"Charge_range")
	table.insert(cfg.plistaoe,"Kick")
	table.insert(cfg.plistaoe,"Victory_health")
	table.insert(cfg.plistaoe,"Shield_Block")
	table.insert(cfg.plistaoe,"Shield_Barrier")
	table.insert(cfg.plistaoe,"Shockwave")
	table.insert(cfg.plistaoe,"Clap_noWounds")
	table.insert(cfg.plistaoe,"Shield_Slam_snb")
	table.insert(cfg.plistaoe,"Revenge")
	table.insert(cfg.plistaoe,"Shield_Slam")
	table.insert(cfg.plistaoe,"execute_SD")
	table.insert(cfg.plistaoe,"hs_6us")
	table.insert(cfg.plistaoe,"Clap")
	table.insert(cfg.plistaoe,"Devastate")
	table.insert(cfg.plistaoe,"hs_nomax")
	--[[table.insert(cfg.plistaoe,"Rend_noRend")
	table.insert(cfg.plistaoe,"Clap")
	table.insert(cfg.plistaoe,"sw")
	table.insert(cfg.plistaoe,"des_noDemo")
	table.insert(cfg.plistaoe,"sb")
	table.insert(cfg.plistaoe,"rv")
	table.insert(cfg.plistaoe,"ss")
	table.insert(cfg.plistaoe,"cleave")
	table.insert(cfg.plistaoe,"bs")]]
	table.insert(cfg.plistaoe,"end")

	cfg.plist=cfg.plistdps

	cfg.case = {}
	cfg.case = {
		["Shield_Block"] = function()
			if lib.GetUnitHealth("player","percent")<=70 then
				return lib.SimpleCDCheck("Shield_Block",lib.GetAura({"Shield_Block"}))
			end
			return nil
		end,
		["Shield_Barrier"] = function()
			if lib.GetUnitHealth("player","percent")<=70 then
				return lib.SimpleCDCheck("Shield_Barrier",lib.GetAura({"Shield_Barrier"}))
			end
			return nil
		end,
		["Clap_noWounds"] = function()
			return lib.SimpleCDCheck("Clap",lib.GetAura({"Deep_Wounds"})-4.5)
		end,
		
		["Shield_Slam_snb"] = function()
			if lib.GetAura({"snb"})>lib.GetSpellCD("Shield_Slam") then
				return lib.SimpleCDCheck("Shield_Slam")
			end
			return nil
		end,
		["hs_6us"] = function ()
			if lib.GetAuraStacks("Unyielding_Strikes")>=6 or lib.GetAura({"Ultimatum"})>lib.GetSpellCD("hs") then
				return lib.SimpleCDCheck("hs")
			end
			return nil
		end,
		["hs_nomax"] = function ()
			if lib.GetUnitHealth("target","percent")>20 and cfg.Power.now>=cfg.Power.max-10 and lib.GetSpellCD(cfg.gcd,true)>0 then
				return lib.SimpleCDCheck("hs")
			end
			return nil
		end,
	
	
		["sw_ths"] = function()
			if lib.GetAuraStacks("ths")==3 then
				return lib.SimpleCDCheck("sw")
			end
			return nil
		end,
		["Clap_bnt"] = function()
			if cfg.bnt and lib.GetAura({"Rend"})>lib.GetSpellCD("Clap") then
				return lib.SimpleCDCheck("Clap",lib.GetAura({"Rend"})-4)
			end
			return nil
		end,
		["Clap_noClap"] = function()
			return lib.SimpleCDCheck("Clap",lib.GetAuras("Clap"))
		end,
		["des_noDemo"] = function()
			return lib.SimpleCDCheck("des",lib.GetAuras("Demo"))
		end,
		["Rend_noRend"] = function()
			return lib.SimpleCDCheck("Rend",lib.GetAura({"Rend"}))
		end,
		["cleave"] = function()
			if cfg.Power.now>65 and lib.GetSpellCD(cfg.gcd,true)>0  then
				return lib.SimpleCDCheck("cleave")
			end
			return nil
		end,
		
		["bs"] = function ()
			if cfg.Power.now<20 then
				return lib.SimpleCDCheck("bs")
			end
			return nil
		end,
	}
	cfg.spells_aoe={"Clap","Shockwave"}
	--cfg.spells_single={"hs"}
	return true
end

lib.classevents["WARRIOR"] = function()
	lib.SetPower("RAGE")
	lib.HideCombo()
	lib.AddResource(cfg.Power.max)
	lib.SetTypeResource("RAGE")
	lib.SetInterrupt("Kick",{6552})
	
	lib.AddSpell("Berserker_Rage",{18499},true) -- Berserker Rage
	lib.AddAura("Enrage",12880,"buff","player") -- Enrage --,18499
	
	lib.AddSpell("Battle_Shout",{6673}) -- Battle Shout
	cfg.case["shout_nobuff"] = function()
		return lib.SimpleCDCheck("Battle_Shout",lib.GetAuras("Attack_Power"))
	end
	
	lib.AddSpell("execute",{5308}) -- Execute
	lib.AddAura("Sudden_Death",52437,"buff","player") -- Sudden Death
	cfg.case["execute_SD"] = function()
		if lib.GetAura({"Sudden_Death"})>lib.GetSpellCD("execute") or cfg.Power.now>=cfg.Power.max-10 then
			return lib.SimpleCDCheck("execute")
		end
		return nil
	end
	
	--lib.AddSpell("Sunder",{7386}) -- Sunder
	--cfg.gcd="Sunder"
	
	--cfg.bnt=0

	lib.AddSpell("strike",{88161}) -- Strike
	lib.AddSpell("Charge",{100}) -- Charge
	cfg.case["Charge_range"] = function()
		if lib.inrange("execute") then return nil end
		return lib.SimpleCDCheck("Charge")
	end
	
	lib.AddSpell("Victory",{103840,34428}) -- Victory Rush/Impending
	cfg.case["Victory_health"] = function()
		if lib.GetUnitHealth("player","percent")<=85 then 
			return lib.SimpleCDCheck("Victory")
		end
		return nil
	end

	lib.AddSpell("hs",{78}) -- Heroic Strike
	
	lib.AddSpell("ht",{57755}) -- Heroic Throw
	
	lib.AddSpell("Recklessness",{1719},true) -- Recklessness
	
	cfg.case["Bloodbath"] = function()
		if (lib.GetSpellCD("Bloodbath")+12>lib.GetSpellCD("Dragon_Roar") or lib.GetSpellCD("Bloodbath")+12>lib.GetSpellCD("Storm Bolt")) then 
			return lib.SimpleCDCheck("Bloodbath")
		end
		return nil
	end
	
	lib.CD = function()
		lib.CDadd("Kick")
		lib.CDadd("Recklessness")
		lib.CDadd("Bloodbath")
		lib.CDadd("Dragon_Roar")
		lib.CDadd("Storm Bolt")
		lib.CDadd("Berserker_Rage")
		lib.CDadd("Charge")
		lib.CDadd("Shield_Block")
		lib.CDadd("Shield_Barrier")
		lib.CDadd("Demoralizing Shout",nil,nil,"turnoff")
		lib.CDadd("Shield Wall",nil,nil,"turnoff")
		lib.CDadd("Last Stand",nil,nil,"turnoff")
	end
	
	cfg.mode = "dps"
	lib.onclick = function()
		if cfg.mode == "dps" then
			cfg.mode = "aoe"
			cfg.plist=cfg.plistaoe
			cfg.Update=true
		else
			cfg.mode = "dps"
			cfg.plist=cfg.plistdps
			cfg.Update=true
		end
	end
	
	lib.rangecheck=function()
		if lib.inrange("execute") then
			lib.bdcolor(Heddmain.bd,nil)
		elseif lib.inrange("Charge") then
			lib.bdcolor(Heddmain.bd,{0,1,0,1})
		elseif lib.inrange("ht") then
			lib.bdcolor(Heddmain.bd,{0,0,1,1})
		else
			lib.bdcolor(Heddmain.bd,{1,0,0,1})
		end
	end
end